CF1771F Hossam and Range Minimum Query 题解

题目链接:CF 或者 洛谷

比较不错的题,出现奇数次出现的这种问题,比较容易想到一种运算,那就是异或和运算。

如果一个区间上一个数出现偶数次,则它对于异或和的贡献为 \(0\),那么很显然,我们维护下区间异或和即可判断一个区间上是否存在出现奇数次的数。然后我们注意到 \(1 \oplus 2 \oplus 3=0\),也即是说,这种符合题意的也有可能异或和为 \(0\),这种问题我们只需要使用随机数构造异或哈希或者字符串哈希之类的,将值域扩展到更大,减少构成这种特殊的包含掩码关系的情况即可。本质就是哈希那套东西搬过来用,这里采用比较简单的,随机数生成的异或哈希。然后注意到它问的不是序列最小的奇数次数,而是值域最小的,那么很显然想到权值线段树去维护哈希情况,但本题又涉及到区间,那么很显然是一个树套树模型。注意到异或和这玩意属于可差性问题,我们可以使用 可持久化线段树 优化一支 \(log\)。查询树上二分根据区间异或和是否为 \(0\) 进行 \(check\)

参照代码
#include <bits/stdc++.h>

// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")

// #define isPbdsFile

#ifdef isPbdsFile

#include <bits/extc++.h>

#else

#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/trie_policy.hpp>
#include <ext/pb_ds/tag_and_trait.hpp>
#include <ext/pb_ds/hash_policy.hpp>
#include <ext/pb_ds/list_update_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/exception.hpp>
#include <ext/rope>

#endif

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef tuple<int, int, int> tii;
typedef tuple<ll, ll, ll> tll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef __int128 i128;
#define hash1 unordered_map
#define hash2 gp_hash_table
#define hash3 cc_hash_table
#define stdHeap std::priority_queue
#define pbdsHeap __gnu_pbds::priority_queue
#define sortArr(a, n) sort(a+1,a+n+1)
#define all(v) v.begin(),v.end()
#define yes cout<<"YES"
#define no cout<<"NO"
#define Spider ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
#define MyFile freopen("..\\input.txt", "r", stdin),freopen("..\\output.txt", "w", stdout);
#define forn(i, a, b) for(int i = a; i <= b; i++)
#define forv(i, a, b) for(int i=a;i>=b;i--)
#define ls(x) (x<<1)
#define rs(x) (x<<1|1)
#define endl '\n'
//用于Miller-Rabin
[[maybe_unused]] static int Prime_Number[13] = {0, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37};

template <typename T>
int disc(T* a, int n)
{
    return unique(a + 1, a + n + 1) - (a + 1);
}

template <typename T>
T lowBit(T x)
{
    return x & -x;
}

template <typename T>
T Rand(T l, T r)
{
    static mt19937 Rand(time(nullptr));
    uniform_int_distribution<T> dis(l, r);
    return dis(Rand);
}

template <typename T1, typename T2>
T1 modt(T1 a, T2 b)
{
    return (a % b + b) % b;
}

template <typename T1, typename T2, typename T3>
T1 qPow(T1 a, T2 b, T3 c)
{
    a %= c;
    T1 ans = 1;
    for (; b; b >>= 1, (a *= a) %= c)if (b & 1)(ans *= a) %= c;
    return modt(ans, c);
}

template <typename T>
void read(T& x)
{
    x = 0;
    T sign = 1;
    char ch = getchar();
    while (!isdigit(ch))
    {
        if (ch == '-')sign = -1;
        ch = getchar();
    }
    while (isdigit(ch))
    {
        x = (x << 3) + (x << 1) + (ch ^ 48);
        ch = getchar();
    }
    x *= sign;
}

template <typename T, typename... U>
void read(T& x, U&... y)
{
    read(x);
    read(y...);
}

template <typename T>
void write(T x)
{
    if (typeid(x) == typeid(char))return;
    if (x < 0)x = -x, putchar('-');
    if (x > 9)write(x / 10);
    putchar(x % 10 ^ 48);
}

template <typename C, typename T, typename... U>
void write(C c, T x, U... y)
{
    write(x), putchar(c);
    write(c, y...);
}


template <typename T11, typename T22, typename T33>
struct T3
{
    T11 one;
    T22 tow;
    T33 three;

    bool operator<(const T3 other) const
    {
        if (one == other.one)
        {
            if (tow == other.tow)return three < other.three;
            return tow < other.tow;
        }
        return one < other.one;
    }

    T3() { one = tow = three = 0; }

    T3(T11 one, T22 tow, T33 three) : one(one), tow(tow), three(three)
    {
    }
};

template <typename T1, typename T2>
void uMax(T1& x, T2 y)
{
    if (x < y)x = y;
}

template <typename T1, typename T2>
void uMin(T1& x, T2 y)
{
    if (x > y)x = y;
}

constexpr int N = 2e5 + 10;
constexpr int MX = 1e9;

struct Node
{
    int left, right;
    int xorSum;
} node[N * 60];

int cnt;
#define left(x) node[x].left
#define right(x) node[x].right
#define xorSum(x) node[x].xorSum
hash2<int, int> mp;

inline void add(const int pre, int& curr, const int pos, const int val, const int l = 0, const int r = MX)
{
    node[curr = ++cnt] = node[pre];
    xorSum(curr) ^= val;
    const int mid = l + r >> 1;
    if (l == r)return;
    if (pos <= mid)add(left(pre),left(curr), pos, val, l, mid);
    else add(right(pre),right(curr), pos, val, mid + 1, r);
}

inline int query(const int L, const int R, const int l = 0, const int r = MX)
{
    if (l == r)return l;
    const int mid = l + r >> 1;
    int leftXor = xorSum(left(R)) ^ xorSum(left(L));
    int rightXor = xorSum(right(R)) ^ xorSum(right(L));
    if (leftXor)return query(left(L),left(R), l, mid);
    if (rightXor)return query(right(L),right(R), mid + 1, r);
    return 0;
}

int n, q;
int x;
int root[N];
int last;

inline void solve()
{
    cin >> n;
    forn(i, 1, n)
    {
        cin >> x;
        if (mp.find(x) == mp.end())mp[x] = Rand(1, MX);
        add(root[i - 1], root[i], x, mp[x]);
    }
    cin >> q;
    while (q--)
    {
        int l, r;
        cin >> l >> r;
        l ^= last, r ^= last;
        cout << (last = query(root[l - 1], root[r])) << endl;
    }
}

signed int main()
{
    // MyFile
    Spider
    //------------------------------------------------------
    // clock_t start = clock();
    int test = 1;
    //    read(test);
    // cin >> test;
    forn(i, 1, test)solve();
    //    while (cin >> n, n)solve();
    //    while (cin >> test)solve();
    // clock_t end = clock();
    // cerr << "time = " << double(end - start) / CLOCKS_PER_SEC << "s" << endl;
}

\[时间复杂度为:\ O((n+q)\log{V_{max}}) \]

posted @ 2024-02-08 21:49  Athanasy  阅读(31)  评论(0编辑  收藏  举报